diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/eht/emlsr-manager.h ns-3.41/src/wifi/model/eht/emlsr-manager.h
--- ns-3.40/src/wifi/model/eht/emlsr-manager.h	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/eht/emlsr-manager.h	2024-02-09 14:44:08.581795000 -0800
@@ -22,7 +22,6 @@
 
 #include "ns3/ctrl-headers.h"
 #include "ns3/mac48-address.h"
-#include "ns3/mgt-headers.h"
 #include "ns3/object.h"
 #include "ns3/sta-wifi-mac.h"
 #include "ns3/wifi-phy-operating-channel.h"
@@ -35,6 +34,7 @@
 {
 
 class EhtFrameExchangeManager;
+class MgtEmlOmn;
 class WifiMpdu;
 
 /**
@@ -74,12 +74,45 @@
     std::optional<Time> GetTransitionTimeout() const;
 
     /**
-     * Set the ID of main PHY (position in the vector of PHYs held by WifiNetDevice). This
-     * method cannot be called during or after initialization.
+     * Set the duration of the MediumSyncDelay timer.
      *
-     * \param mainPhyId the ID of the main PHY
+     * \param duration the duration of the MediumSyncDelay timer
      */
-    void SetMainPhyId(uint8_t mainPhyId);
+    void SetMediumSyncDuration(Time duration);
+
+    /**
+     * \return the duration of the MediumSyncDelay timer
+     */
+    Time GetMediumSyncDuration() const;
+
+    /**
+     * Set the Medium Synchronization OFDM ED threshold (dBm) to use while the MediumSyncDelay
+     * timer is running.
+     *
+     * \param threshold the threshold in dBm (ranges from -72 to -62 dBm)
+     */
+    void SetMediumSyncOfdmEdThreshold(int8_t threshold);
+
+    /**
+     * \return the Medium Synchronization OFDM ED threshold (dBm) to use while the MediumSyncDelay
+     * timer is running.
+     */
+    int8_t GetMediumSyncOfdmEdThreshold() const;
+
+    /**
+     * Set the maximum number of TXOPs a non-AP STA is allowed to attempt to initiate while
+     * the MediumSyncDelay timer is running. No value indicates no limit.
+     *
+     * \param nTxops the maximum number of TXOPs a non-AP STA is allowed to attempt to
+     *               initiate while the MediumSyncDelay timer is running
+     */
+    void SetMediumSyncMaxNTxops(std::optional<uint8_t> nTxops);
+
+    /**
+     * \return the maximum number of TXOPs a non-AP STA is allowed to attempt to initiate while
+     * the MediumSyncDelay timer is running. No value indicates no limit.
+     */
+    std::optional<uint8_t> GetMediumSyncMaxNTxops() const;
 
     /**
      * \return the ID of main PHY (position in the vector of PHYs held by WifiNetDevice)
@@ -115,6 +148,18 @@
     bool GetCamStateReset() const;
 
     /**
+     * Set the member variable indicating whether Aux PHYs are capable of transmitting PPDUs.
+     *
+     * \param capable whether Aux PHYs are capable of transmitting PPDUs
+     */
+    void SetAuxPhyTxCapable(bool capable);
+
+    /**
+     * \return whether Aux PHYs are capable of transmitting PPDUs
+     */
+    bool GetAuxPhyTxCapable() const;
+
+    /**
      * Notify the reception of a management frame addressed to us.
      *
      * \param mpdu the received MPDU
@@ -133,8 +178,10 @@
      * Notify the start of an UL TXOP on the given link
      *
      * \param linkId the ID of the given link
+     * \param timeToCtsEnd time remaining to the end of CTS reception, in case the UL TXOP is
+     *                     started by an aux PHY
      */
-    void NotifyUlTxopStart(uint8_t linkId);
+    void NotifyUlTxopStart(uint8_t linkId, std::optional<Time> timeToCtsEnd);
 
     /**
      * Notify the end of a TXOP on the given link.
@@ -143,6 +190,54 @@
      */
     void NotifyTxopEnd(uint8_t linkId);
 
+    /**
+     * Check whether the MediumSyncDelay timer is running for the STA operating on the given link.
+     * If so, returns the time elapsed since the timer started.
+     *
+     * \param linkId the ID of the given link
+     * \return the time elapsed since the MediumSyncDelay timer started, if this timer is running
+     *         for the STA operating on the given link
+     */
+    std::optional<Time> GetElapsedMediumSyncDelayTimer(uint8_t linkId) const;
+
+    /**
+     * Cancel the MediumSyncDelay timer associated with the given link and take the appropriate
+     * actions. This function must not be called when the MediumSyncDelay timer is not running
+     * on the given link.
+     *
+     * \param linkId the ID of the link associated with the MediumSyncDelay timer to cancel
+     */
+    void CancelMediumSyncDelayTimer(uint8_t linkId);
+
+    /**
+     * Decrement the counter indicating the number of TXOP attempts left while the MediumSyncDelay
+     * timer is running. This function must not be called when the MediumSyncDelay timer is not
+     * running on the given link.
+     *
+     * \param linkId the ID of the link on which a new TXOP attempt may be carried out
+     */
+    void DecrementMediumSyncDelayNTxops(uint8_t linkId);
+
+    /**
+     * Reset the counter indicating the number of TXOP attempts left while the MediumSyncDelay
+     * timer is running, so as to remove the limit on the number of attempts that can be made
+     * while the MediumSyncDelay timer is running. This function is normally called when a TXOP
+     * attempt is successful. This function must not be called when the MediumSyncDelay timer is
+     * not running on the given link.
+     *
+     * \param linkId the ID of the link for which the counter of the TXOP attempts is reset
+     */
+    void ResetMediumSyncDelayNTxops(uint8_t linkId);
+
+    /**
+     * Return whether no more TXOP attempt is allowed on the given link. This function must not
+     * be called when the MediumSyncDelay timer is not running on the given link.
+     *
+     * \param linkId the ID of the link on which a new TXOP attempt may be carried out
+     * \return whether no more TXOP attempt on the given link is allowed
+     */
+    bool MediumSyncDelayNTxopsExceeded(uint8_t linkId);
+
   protected:
     void DoDispose() override;
 
@@ -186,6 +281,42 @@
     const WifiPhyOperatingChannel& GetChannelForAuxPhy(uint8_t linkId) const;
 
     /**
+     * Switch channel on the Main PHY so that it operates on the given link.
+     *
+     * \param linkId the ID of the link on which the main PHY has to operate
+     * \param noSwitchDelay whether switching delay should be zero
+     * \param resetBackoff whether backoff should be reset on the link on which the main PHY
+     *                     is operating
+     * \param requestAccess whether channel access should be requested on the link on which the
+     *                      main PHY is moving onto
+     */
+    void SwitchMainPhy(uint8_t linkId, bool noSwitchDelay, bool resetBackoff, bool requestAccess);
+
+    static constexpr bool RESET_BACKOFF = true;       //!< reset backoff on main PHY switch
+    static constexpr bool DONT_RESET_BACKOFF = false; //!< do not reset backoff on main PHY switch
+    static constexpr bool REQUEST_ACCESS = true; //!< request channel access when PHY switch ends
+    static constexpr bool DONT_REQUEST_ACCESS =
+        false; //!< do not request channel access when PHY switch ends
+
+    /**
+     * Switch channel on the Aux PHY operating on the given current link so that it operates
+     * on the given next link.
+     *
+     * \param currLinkId the ID of the link on which the aux PHY is currently operating
+     * \param nextLinkId the ID of the link on which the aux PHY will be operating
+     */
+    void SwitchAuxPhy(uint8_t currLinkId, uint8_t nextLinkId);
+
+    /**
+     * Set the CCA ED threshold (if needed) on the given PHY that is switching channel to
+     * operate on the given link.
+     *
+     * \param phy the given PHY
+     * \param linkId the ID of the given link
+     */
+    void SetCcaEdThresholdOnLinkSwitch(Ptr<WifiPhy> phy, uint8_t linkId);
+
+    /**
      * \return the EML Operating Mode Notification to send
      */
     MgtEmlOmn GetEmlOmn();
@@ -193,10 +324,20 @@
     Time m_emlsrPaddingDelay;    //!< EMLSR Padding delay
     Time m_emlsrTransitionDelay; //!< EMLSR Transition delay
     uint8_t m_mainPhyId; //!< ID of main PHY (position in the vector of PHYs held by WifiNetDevice)
-    uint16_t m_auxPhyMaxWidth; //!< max channel width (MHz) supported by aux PHYs
+    uint16_t m_auxPhyMaxWidth;               //!< max channel width (MHz) supported by aux PHYs
+    WifiModulationClass m_auxPhyMaxModClass; //!< max modulation class supported by aux PHYs
+    bool m_auxPhyTxCapable;                  //!< whether Aux PHYs are capable of transmitting PPDUs
 
   private:
     /**
+     * Set the ID of main PHY (position in the vector of PHYs held by WifiNetDevice). This
+     * method cannot be called during or after initialization.
+     *
+     * \param mainPhyId the ID of the main PHY
+     */
+    void SetMainPhyId(uint8_t mainPhyId);
+
+    /**
      * Compute the operating channels that the main PHY and the aux PHY(s) must switch to in order
      * to operate on each of the setup links. The operating channels may be different due to
      * limited channel width capabilities of the aux PHY(s). This method shall be called upon
@@ -210,6 +351,22 @@
     void SendEmlOmn();
 
     /**
+     * Start the MediumSyncDelay timer and take the appropriate actions, if the timer is not
+     * already running.
+     *
+     * \param linkId the ID of the link on which a TXOP was carried out that caused the STAs
+     *               operating on other links to lose medium synchronization
+     */
+    void StartMediumSyncDelayTimer(uint8_t linkId);
+
+    /**
+     * Take the appropriate actions when the MediumSyncDelay timer expires or is cancelled.
+     *
+     * \param linkId the ID of the link associated with the MediumSyncDelay timer to cancel
+     */
+    void MediumSyncDelayTimerExpired(uint8_t linkId);
+
+    /**
      * Notify the subclass of the reception of a management frame addressed to us.
      *
      * \param mpdu the received MPDU
@@ -218,6 +375,27 @@
     virtual void DoNotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId) = 0;
 
     /**
+     * Notify the subclass of the reception of an initial Control frame on the given link.
+     *
+     * \param linkId the ID of the link on which the initial Control frame was received
+     */
+    virtual void DoNotifyIcfReceived(uint8_t linkId) = 0;
+
+    /**
+     * Notify the subclass of the start of an UL TXOP on the given link
+     *
+     * \param linkId the ID of the given link
+     */
+    virtual void DoNotifyUlTxopStart(uint8_t linkId) = 0;
+
+    /**
+     * Notify the subclass of the end of a TXOP on the given link.
+     *
+     * \param linkId the ID of the given link
+     */
+    virtual void DoNotifyTxopEnd(uint8_t linkId) = 0;
+
+    /**
      * Notify the acknowledgment of the given MPDU.
      *
      * \param mpdu the acknowledged MPDU
@@ -239,18 +417,10 @@
     void ChangeEmlsrMode();
 
     /**
-     * Switch channel on the Main PHY so that it operates on the given link.
-     *
-     * \param linkId the ID of the link on which the main PHY has to operate
-     * \param noSwitchDelay whether switching delay should be zero
-     */
-    void SwitchMainPhy(uint8_t linkId, bool noSwitchDelay);
-
-    /**
      * Adjust the operating channel of all the aux PHYs to meet the constraint on the maximum
      * channel width supported by aux PHYs.
      */
-    void ApplyMaxChannelWidthOnAuxPhys();
+    void ApplyMaxChannelWidthAndModClassOnAuxPhys();
 
     /**
      * Notify subclass that EMLSR mode changed.
@@ -265,9 +435,30 @@
      */
     virtual void NotifyMainPhySwitch(uint8_t currLinkId, uint8_t nextLinkId) = 0;
 
+    /**
+     * Information about the status of the MediumSyncDelay timer associated with a link.
+     */
+    struct MediumSyncDelayStatus
+    {
+        EventId timer;                        //!< the MediumSyncDelay timer
+        std::optional<uint8_t> msdNTxopsLeft; //!< number of TXOP attempts left while the
+                                              //!< MediumSyncDelay timer is running
+    };
+
     Ptr<StaWifiMac> m_staMac;                     //!< the MAC of the managed non-AP MLD
     std::optional<Time> m_emlsrTransitionTimeout; /**< Transition timeout advertised by APs with
                                                        EMLSR activated */
+    Time m_mediumSyncDuration;                    //!< duration of the MediumSyncDelay timer
+    int8_t m_msdOfdmEdThreshold;                  //!< MediumSyncDelay OFDM ED threshold
+    std::optional<uint8_t> m_msdMaxNTxops;        //!< MediumSyncDelay max number of TXOPs
+
+    std::map<uint8_t, MediumSyncDelayStatus>
+        m_mediumSyncDelayStatus; //!< the status of MediumSyncDelay timers (link ID-indexed)
+    std::map<Ptr<WifiPhy>, double> m_prevCcaEdThreshold; //!< the CCA sensitivity threshold (dBm)
+                                                         //!< to restore once the MediumSyncDelay
+                                                         //!< timer expires or the PHY moves to a
+                                                         //!< link on which the timer is not running
+
     std::set<uint8_t> m_emlsrLinks; //!< ID of the EMLSR links (empty if EMLSR mode is disabled)
     std::optional<std::set<uint8_t>> m_nextEmlsrLinks; /**< ID of the links that will become the
                                                             EMLSR links when the pending
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/eht/multi-link-element.cc ns-3.41/src/wifi/model/eht/multi-link-element.cc
--- ns-3.40/src/wifi/model/eht/multi-link-element.cc	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/eht/multi-link-element.cc	2024-02-09 14:44:08.581795000 -0800
@@ -219,6 +219,79 @@
     return MicroSeconds(1 << (3 + value));
 }
 
+void
+CommonInfoBasicMle::SetMediumSyncDelayTimer(Time delay)
+{
+    int64_t delayUs = delay.GetMicroSeconds();
+    NS_ABORT_MSG_IF(delayUs % 32 != 0, "Delay must be a multiple of 32 microseconds");
+    delayUs /= 32;
+
+    if (!m_mediumSyncDelayInfo.has_value())
+    {
+        m_mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
+    }
+    m_mediumSyncDelayInfo->mediumSyncDuration = (delayUs & 0xff);
+}
+
+Time
+CommonInfoBasicMle::GetMediumSyncDelayTimer() const
+{
+    NS_ASSERT(m_mediumSyncDelayInfo);
+    return MicroSeconds(m_mediumSyncDelayInfo->mediumSyncDuration * 32);
+}
+
+void
+CommonInfoBasicMle::SetMediumSyncOfdmEdThreshold(int8_t threshold)
+{
+    NS_ABORT_MSG_IF(threshold < -72 || threshold > -62, "Threshold may range from -72 to -62 dBm");
+    uint8_t value = 72 + threshold;
+
+    if (!m_mediumSyncDelayInfo.has_value())
+    {
+        m_mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
+    }
+    m_mediumSyncDelayInfo->mediumSyncOfdmEdThreshold = value;
+}
+
+int8_t
+CommonInfoBasicMle::GetMediumSyncOfdmEdThreshold() const
+{
+    NS_ASSERT(m_mediumSyncDelayInfo);
+    return (m_mediumSyncDelayInfo->mediumSyncOfdmEdThreshold) - 72;
+}
+
+void
+CommonInfoBasicMle::SetMediumSyncMaxNTxops(uint8_t nTxops)
+{
+    NS_ASSERT_MSG(nTxops < 16, "Value " << +nTxops << "cannot be encoded in 4 bits");
+
+    if (!m_mediumSyncDelayInfo.has_value())
+    {
+        m_mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
+    }
+
+    if (nTxops == 0)
+    {
+        // no limit on max number of TXOPs
+        m_mediumSyncDelayInfo->mediumSyncMaxNTxops = 15;
+        return;
+    }
+
+    m_mediumSyncDelayInfo->mediumSyncMaxNTxops = --nTxops;
+}
+
+std::optional<uint8_t>
+CommonInfoBasicMle::GetMediumSyncMaxNTxops() const
+{
+    NS_ASSERT(m_mediumSyncDelayInfo);
+    uint8_t nTxops = m_mediumSyncDelayInfo->mediumSyncMaxNTxops;
+    if (nTxops == 15)
+    {
+        return std::nullopt;
+    }
+    return nTxops + 1;
+}
+
 /**
  * MultiLinkElement
  */
@@ -330,81 +403,6 @@
 }
 
 void
-MultiLinkElement::SetMediumSyncDelayTimer(Time delay)
-{
-    int64_t delayUs = delay.GetMicroSeconds();
-    NS_ABORT_MSG_IF(delayUs % 32 != 0, "Delay must be a multiple of 32 microseconds");
-    delayUs /= 32;
-
-    auto& mediumSyncDelayInfo = std::get<BASIC_VARIANT>(m_commonInfo).m_mediumSyncDelayInfo;
-    if (!mediumSyncDelayInfo.has_value())
-    {
-        mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
-    }
-    mediumSyncDelayInfo.value().mediumSyncDuration = (delayUs & 0xff);
-}
-
-Time
-MultiLinkElement::GetMediumSyncDelayTimer() const
-{
-    return MicroSeconds(
-        (std::get<BASIC_VARIANT>(m_commonInfo).m_mediumSyncDelayInfo.value().mediumSyncDuration) *
-        32);
-}
-
-void
-MultiLinkElement::SetMediumSyncOfdmEdThreshold(int8_t threshold)
-{
-    NS_ABORT_MSG_IF(threshold < -72 || threshold > -62, "Threshold may range from -72 to -62 dBm");
-    uint8_t value = 72 + threshold;
-
-    auto& mediumSyncDelayInfo = std::get<BASIC_VARIANT>(m_commonInfo).m_mediumSyncDelayInfo;
-    if (!mediumSyncDelayInfo.has_value())
-    {
-        mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
-    }
-    mediumSyncDelayInfo.value().mediumSyncOfdmEdThreshold = value;
-}
-
-int8_t
-MultiLinkElement::GetMediumSyncOfdmEdThreshold() const
-{
-    return (std::get<BASIC_VARIANT>(m_commonInfo)
-                .m_mediumSyncDelayInfo.value()
-                .mediumSyncOfdmEdThreshold) -
-           72;
-}
-
-void
-MultiLinkElement::SetMediumSyncMaxNTxops(uint8_t nTxops)
-{
-    NS_ASSERT(nTxops > 0);
-    nTxops--;
-
-    auto& mediumSyncDelayInfo = std::get<BASIC_VARIANT>(m_commonInfo).m_mediumSyncDelayInfo;
-    if (!mediumSyncDelayInfo.has_value())
-    {
-        mediumSyncDelayInfo = CommonInfoBasicMle::MediumSyncDelayInfo{};
-    }
-    mediumSyncDelayInfo.value().mediumSyncMaxNTxops = (nTxops & 0x0f);
-}
-
-uint8_t
-MultiLinkElement::GetMediumSyncMaxNTxops() const
-{
-    return (std::get<BASIC_VARIANT>(m_commonInfo)
-                .m_mediumSyncDelayInfo.value()
-                .mediumSyncMaxNTxops) +
-           1;
-}
-
-bool
-MultiLinkElement::HasMediumSyncDelayInfo() const
-{
-    return std::get<BASIC_VARIANT>(m_commonInfo).m_mediumSyncDelayInfo.has_value();
-}
-
-void
 MultiLinkElement::SetEmlsrSupported(bool supported)
 {
     auto& emlCapabilities = std::get<BASIC_VARIANT>(m_commonInfo).m_emlCapabilities;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/eht/multi-link-element.h ns-3.41/src/wifi/model/eht/multi-link-element.h
--- ns-3.40/src/wifi/model/eht/multi-link-element.h	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/eht/multi-link-element.h	2024-02-09 14:44:08.581795000 -0800
@@ -140,6 +140,54 @@
      * \return the corresponding EMLSR Transition delay
      */
     static Time DecodeEmlsrTransitionDelay(uint8_t value);
+
+    /**
+     * Set the Medium Synchronization Duration subfield of the Medium Synchronization
+     * Delay Information in the Common Info field.
+     *
+     * \param delay the timer duration (must be a multiple of 32 microseconds)
+     */
+    void SetMediumSyncDelayTimer(Time delay);
+    /**
+     * Set the Medium Synchronization OFDM ED Threshold subfield of the Medium Synchronization
+     * Delay Information in the Common Info field.
+     *
+     * \param threshold the threshold in dBm (ranges from -72 to -62 dBm)
+     */
+    void SetMediumSyncOfdmEdThreshold(int8_t threshold);
+    /**
+     * Set the Medium Synchronization Maximum Number of TXOPs subfield of the Medium Synchronization
+     * Delay Information in the Common Info field. A value of zero indicates no limit on the
+     * maximum number of TXOPs.
+     *
+     * \param nTxops the maximum number of TXOPs a non-AP STA is allowed to attempt to
+     *               initiate while the MediumSyncDelay timer is running at a non-AP STA
+     */
+    void SetMediumSyncMaxNTxops(uint8_t nTxops);
+    /**
+     * Get the Medium Synchronization Duration subfield of the Medium Synchronization Delay
+     * Information in the Common Info field. Make sure that the Medium Synchronization Delay
+     * Information subfield is present.
+     *
+     * \return the timer duration
+     */
+    Time GetMediumSyncDelayTimer() const;
+    /**
+     * Get the Medium Synchronization OFDM ED Threshold in dBm. Make sure that the Medium
+     * Synchronization Delay Information subfield is present.
+     *
+     * \return the threshold in dBm
+     */
+    int8_t GetMediumSyncOfdmEdThreshold() const;
+    /**
+     * Get the maximum number of TXOPs a non-AP STA is allowed to attempt to initiate
+     * while the MediumSyncDelay timer is running at a non-AP STA. If no value is returned,
+     * no limit is imposed on the number of TXOPs. Make sure that the Medium Synchronization
+     * Delay Information subfield is present.
+     *
+     * \return the number of TXOPs
+     */
+    std::optional<uint8_t> GetMediumSyncMaxNTxops() const;
 };
 
 /**
@@ -286,64 +334,6 @@
     uint8_t GetBssParamsChangeCount() const;
 
     /**
-     * Set the Medium Synchronization Duration subfield of the Medium Synchronization
-     * Delay information in the Common Info field. Make sure that this is a Basic
-     * Multi-Link Element.
-     *
-     * \param delay the timer duration (must be a multiple of 32 microseconds)
-     */
-    void SetMediumSyncDelayTimer(Time delay);
-    /**
-     * Set the Medium Synchronization OFDM ED Threshold subfield of the Medium Synchronization
-     * Delay information in the Common Info field. Make sure that this is a Basic
-     * Multi-Link Element.
-     *
-     * \param threshold the threshold in dBm (ranges from -72 to -62 dBm)
-     */
-    void SetMediumSyncOfdmEdThreshold(int8_t threshold);
-    /**
-     * Set the Medium Synchronization Maximum Number of TXOPs subfield of the Medium Synchronization
-     * Delay information in the Common Info field. Make sure that this is a Basic
-     * Multi-Link Element.
-     *
-     * \param nTxops the maximum number of TXOPs a non-AP STA is allowed to attempt to
-     *               initiate while the MediumSyncDelay timer is running at a non-AP STA
-     */
-    void SetMediumSyncMaxNTxops(uint8_t nTxops);
-    /**
-     * Return true if the Medium Synchronization Delay Information subfield in the
-     * Common Info field is present and false otherwise. Make sure that this is a Basic
-     * Multi-Link Element.
-     *
-     * \return true if the Medium Synchronization Delay Information subfield in the
-     * Common Info field is present and false otherwise
-     */
-    bool HasMediumSyncDelayInfo() const;
-    /**
-     * Get the Medium Synchronization Duration subfield of the Medium Synchronization
-     * Delay information in the Common Info field. Make sure that this is a Basic
-     * Multi-Link Element and the Medium Synchronization Duration subfield is present.
-     *
-     * \return the timer duration
-     */
-    Time GetMediumSyncDelayTimer() const;
-    /**
-     * Get the Medium Synchronization OFDM ED Threshold in dBm. Make sure that this is a Basic
-     * Multi-Link Element and the Medium Synchronization Duration subfield is present.
-     *
-     * \return the threshold in dBm
-     */
-    int8_t GetMediumSyncOfdmEdThreshold() const;
-    /**
-     * Get the maximum number of TXOPs a non-AP STA is allowed to attempt to initiate
-     * while the MediumSyncDelay timer is running at a non-AP STA. Make sure that this is a
-     * Basic Multi-Link Element and the Medium Synchronization Duration subfield is present.
-     *
-     * \return the number of TXOPs
-     */
-    uint8_t GetMediumSyncMaxNTxops() const;
-
-    /**
      * Set the EMLSR Support subfield of the EML Capabilities subfield in the Common Info field
      * to 1 if EMLSR mode is supported and set it to 0 otherwise. Make sure that this is a Basic
      * Multi-Link Element.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/error-rate-model.cc ns-3.41/src/wifi/model/error-rate-model.cc
--- ns-3.40/src/wifi/model/error-rate-model.cc	2023-09-27 13:30:37.902840000 -0700
+++ ns-3.41/src/wifi/model/error-rate-model.cc	2024-02-09 14:44:08.581795000 -0800
@@ -44,7 +44,7 @@
     double precision;
     low = 1e-25;
     high = 1e25;
-    precision = 2e-12;
+    precision = 8e-12;
     while (high - low > precision)
     {
         NS_ASSERT(high >= low);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/fcfs-wifi-queue-scheduler.cc ns-3.41/src/wifi/model/fcfs-wifi-queue-scheduler.cc
--- ns-3.40/src/wifi/model/fcfs-wifi-queue-scheduler.cc	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/fcfs-wifi-queue-scheduler.cc	2024-02-09 14:44:08.581795000 -0800
@@ -66,19 +66,20 @@
 TypeId
 FcfsWifiQueueScheduler::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::FcfsWifiQueueScheduler")
-                            .SetParent<WifiMacQueueSchedulerImpl<Time>>()
-                            .SetGroupName("Wifi")
-                            .AddConstructor<FcfsWifiQueueScheduler>()
-                            .AddAttribute("DropPolicy",
-                                          "Upon enqueue with full queue, drop oldest (DropOldest) "
-                                          "or newest (DropNewest) packet",
-                                          EnumValue(DROP_NEWEST),
-                                          MakeEnumAccessor(&FcfsWifiQueueScheduler::m_dropPolicy),
-                                          MakeEnumChecker(FcfsWifiQueueScheduler::DROP_OLDEST,
-                                                          "DropOldest",
-                                                          FcfsWifiQueueScheduler::DROP_NEWEST,
-                                                          "DropNewest"));
+    static TypeId tid =
+        TypeId("ns3::FcfsWifiQueueScheduler")
+            .SetParent<WifiMacQueueSchedulerImpl<Time>>()
+            .SetGroupName("Wifi")
+            .AddConstructor<FcfsWifiQueueScheduler>()
+            .AddAttribute("DropPolicy",
+                          "Upon enqueue with full queue, drop oldest (DropOldest) "
+                          "or newest (DropNewest) packet",
+                          EnumValue(DROP_NEWEST),
+                          MakeEnumAccessor<DropPolicy>(&FcfsWifiQueueScheduler::m_dropPolicy),
+                          MakeEnumChecker(FcfsWifiQueueScheduler::DROP_OLDEST,
+                                          "DropOldest",
+                                          FcfsWifiQueueScheduler::DROP_NEWEST,
+                                          "DropNewest"));
     return tid;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/frame-exchange-manager.cc ns-3.41/src/wifi/model/frame-exchange-manager.cc
--- ns-3.40/src/wifi/model/frame-exchange-manager.cc	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/frame-exchange-manager.cc	2024-02-09 14:44:08.581795000 -0800
@@ -415,12 +415,6 @@
     }
 
     StartProtection(m_txParams);
-
-    if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE)
-    {
-        // we are done with frames that do not require acknowledgment
-        m_mpdu = nullptr;
-    }
 }
 
 void
@@ -473,14 +467,17 @@
 
     if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NONE)
     {
-        Simulator::Schedule(txDuration, &FrameExchangeManager::TransmissionSucceeded, this);
-
         if (!m_mpdu->GetHeader().IsQosData() ||
             m_mpdu->GetHeader().GetQosAckPolicy() == WifiMacHeader::NO_ACK)
         {
             // No acknowledgment, hence dequeue the MPDU if it is stored in a queue
             DequeueMpdu(m_mpdu);
         }
+
+        Simulator::Schedule(txDuration, [=, this]() {
+            TransmissionSucceeded();
+            m_mpdu = nullptr;
+        });
     }
     else if (m_txParams.m_acknowledgment->method == WifiAcknowledgment::NORMAL_ACK)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/he/he-configuration.cc ns-3.41/src/wifi/model/he/he-configuration.cc
--- ns-3.40/src/wifi/model/he/he-configuration.cc	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/he/he-configuration.cc	2024-02-09 14:44:08.585795000 -0800
@@ -67,11 +67,12 @@
                                            &HeConfiguration::SetMaxTbPpduDelay),
                           MakeTimeChecker(Seconds(0)))
             .AddAttribute("MpduBufferSize",
-                          "The MPDU buffer size for receiving A-MPDUs",
+                          "This attribute is obsolete. Use the WifiMac::MpduBufferSize attribute "
+                          "instead.",
                           UintegerValue(64),
-                          MakeUintegerAccessor(&HeConfiguration::GetMpduBufferSize,
-                                               &HeConfiguration::SetMpduBufferSize),
-                          MakeUintegerChecker<uint16_t>(64, 256))
+                          MakeUintegerAccessor(&HeConfiguration::m_mpduBufferSize),
+                          MakeUintegerChecker<uint16_t>(64, 256),
+                          TypeId::OBSOLETE)
             .AddAttribute("MuBeAifsn",
                           "AIFSN used by BE EDCA when the MU EDCA Timer is running. "
                           "It must be either zero (EDCA disabled) or a value from 2 to 15.",
@@ -223,17 +224,4 @@
     m_maxTbPpduDelay = maxTbPpduDelay;
 }
 
-void
-HeConfiguration::SetMpduBufferSize(uint16_t size)
-{
-    NS_LOG_FUNCTION(this << size);
-    m_mpduBufferSize = size;
-}
-
-uint16_t
-HeConfiguration::GetMpduBufferSize() const
-{
-    return m_mpduBufferSize;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/he/he-configuration.h ns-3.41/src/wifi/model/he/he-configuration.h
--- ns-3.40/src/wifi/model/he/he-configuration.h	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/he/he-configuration.h	2024-02-09 14:44:08.585795000 -0800
@@ -68,14 +68,6 @@
      * \return the maximum TB PPDU delay
      */
     Time GetMaxTbPpduDelay() const;
-    /**
-     * \param size the MPDU buffer size to receive A-MPDUs
-     */
-    void SetMpduBufferSize(uint16_t size);
-    /**
-     * \return the MPDU buffer size to receive A-MPDUs
-     */
-    uint16_t GetMpduBufferSize() const;
 
   private:
     Time m_guardInterval;      //!< Supported HE guard interval
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/he/he-frame-exchange-manager.cc ns-3.41/src/wifi/model/he/he-frame-exchange-manager.cc
--- ns-3.40/src/wifi/model/he/he-frame-exchange-manager.cc	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/he/he-frame-exchange-manager.cc	2024-02-09 14:44:08.585795000 -0800
@@ -96,17 +96,6 @@
     VhtFrameExchangeManager::Reset();
 }
 
-uint16_t
-HeFrameExchangeManager::GetSupportedBaBufferSize() const
-{
-    NS_ASSERT(m_mac->GetHeConfiguration());
-    if (m_mac->GetHeConfiguration()->GetMpduBufferSize() > 64)
-    {
-        return 256;
-    }
-    return 64;
-}
-
 void
 HeFrameExchangeManager::SetWifiMac(const Ptr<WifiMac> mac)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/model/he/he-frame-exchange-manager.h ns-3.41/src/wifi/model/he/he-frame-exchange-manager.h
--- ns-3.40/src/wifi/model/he/he-frame-exchange-manager.h	2023-09-27 13:30:37.906839800 -0700
+++ ns-3.41/src/wifi/model/he/he-frame-exchange-manager.h	2024-02-09 14:44:08.585795000 -0800
@@ -75,7 +75,6 @@
     HeFrameExchangeManager();
     ~HeFrameExchangeManager() override;
 
-    uint16_t GetSupportedBaBufferSize() const override;
     bool StartFrameExchange(Ptr<QosTxop> edca, Time availableTime, bool initialFrame) override;
     void SetWifiMac(const Ptr<WifiMac> mac) override;
     void CalculateAcknowledgmentTime(WifiAcknowledgment* acknowledgment) const override;
